<?php 
/**
 * Plugin Name: IP 2 Hostname (Matomo Plugin)
 * Plugin URI: http://plugins.matomo.org/Ip2Hostname
 * Description: Piwik plugin to get the hostname from the visitor IP
 * Author: Martin Keckeis
 * Author URI: https://github.com/ThaDafinser/Piwik-Ip2Hostname
 * Version: 3.0.0
 */
?><?php
namespace Piwik\Plugins\Ip2Hostname;

use Piwik\Plugin;

 
if (defined( 'ABSPATH')
&& function_exists('add_action')) {
    $path = '/matomo/app/core/Plugin.php';
    if (defined('WP_PLUGIN_DIR') && WP_PLUGIN_DIR && file_exists(WP_PLUGIN_DIR . $path)) {
        require_once WP_PLUGIN_DIR . $path;
    } elseif (defined('WPMU_PLUGIN_DIR') && WPMU_PLUGIN_DIR && file_exists(WPMU_PLUGIN_DIR . $path)) {
        require_once WPMU_PLUGIN_DIR . $path;
    } else {
        return;
    }
    add_action('plugins_loaded', function () {
        if (function_exists('matomo_add_plugin')) {
            matomo_add_plugin(__DIR__, __FILE__, true);
        }
    });
}

class Ip2Hostname extends Plugin
{

    /**
     *
     * @see Piwik\Plugin::registerEvents
     */
    public function registerEvents()
    {
        return [
            'Live.getAllVisitorDetails' => 'getAllVisitorDetails',
        ];
    }

    public function getAllVisitorDetails(&$visitor, $details)
    {
        if (isset($visitor['visitIp']) && isset($details['location_hostname']) && $details['location_hostname'] != '') {
            $visitor['visitIp'] = $visitor['visitIp'] . ' | ' . $details['location_hostname'];
        } elseif (isset($details['location_hostname']) && $details['location_hostname'] != '') {
            $visitor['visitIp'] = $details['location_hostname'];
        }
    }
}
